Index: trunk/SophyaLib/Manual/modifs.tex
===================================================================
--- trunk/SophyaLib/Manual/modifs.tex	(revision 2942)
+++ trunk/SophyaLib/Manual/modifs.tex	(revision 2971)
@@ -56,5 +56,8 @@
 \section{BuildMgr} 
 \begin{itemize}
-\item[\rond] Dec 2005 :  Portage sur AIX - xlC 
+\item[\rond] Juin 2006 :  Ajout targets cleanobj prgall tests prgutil
+\item[\rond] Avril 2006 :  suppression de libextsophya.so pour fabriquer libPI.so 
+(PIext rendu independant de FitsIOServer) 
+\item[\rond] Dec 2005/Jan 2006 :  Portage sur AIX - xlC 
 \item[\rond] Dec 2005 : check Compil avec icc , compil avec gcc-4
 \item[\rond] Avril-Mai 2005 : Introduction de la nouvelle version de
@@ -154,5 +157,6 @@
 - Compil avec g++ 4 : ajouts fichiers declarations privees tmatrix\_tsnl.h tvector\_tsnl.h 
 
-\item[\rond] Optimisation de la multiplication matricielle (CMV) - Extrait du 
+\item[\rond] Juillet 2004 \\
+- Optimisation de la multiplication matricielle (CMV) - Extrait du 
 message (from CMV) du 30 Juillet 2004: \\
 \begin{verbatim}
@@ -210,5 +214,5 @@
 \end{verbatim}
 
-\item[\rond] Optimisation operations diverses, en particulier \\
+\item[\rond] Juillet 2004 : Optimisation operations diverses, en particulier \\
 1) Remplacement des methodes Add/Sub/Mul/DivElt(a) par
    Add/Sub/Mul/DivElt(TArray a, TArray res) \\
@@ -375,4 +379,17 @@
 
 \section{SkyMap , Samba }
+
+\subsection{Samba: SphericalTransformServer}
+{\bf Mai 2006:} Optimisation calcul transform en harmoniques sphriques - 
+Extrait de cvs log :
+\begin{verbatim}
+revision 1.8
+date: 2006/06/01 11:34:50;  author: ansari;  state: Exp;  lines: +147 -12
+1/ passage en sa_size_t (au lieu de int) dans Alm<T> et Bm<T>
+2/ Ajout des methodes optimisees (statiques) pour calcul transforme Ylm
+ds LambdaLMBuilder et utilisation ds SphericalTransformServer
+                             Reza , 1/06/2006
+\end{verbatim}
+
 \subsection{Tests et vrifications des polynomes de Legendre} 
 CMV ???
@@ -420,5 +437,37 @@
 
 \section{SysTools} 
+{\bf Mai-Juin 2006 } classe ZThread - petites modifs/amliorations lies
+ la gestion des signaux et mthodes kill 
+
 \subsection{Classe SOPHYA::Commander (module SysTools) }
+Mai-Juin 2006:
+Debug (?) de gestion/controle des threads dans la classe Commander - 
+Extrait de cvs log : 
+\begin{verbatim}
+date: 2006/05/29 17:27:35;  author: ansari;  state: Exp;  lines: +62 -11
+Ajout gestionnaire signal ds ZThread et correction/adaptation gestion des thread
+s (killthr) dans Commander - Reza 29 mai 2006
+----------------------------
+revision 1.7
+date: 2006/04/26 15:22:09;  author: ansari;  state: Exp;  lines: +13 -0
+ajout methode ZThread::kill() pour envoi de signal a un thread + remplacement Ca
+ncelThread par StopThread (par kill/SIGUSR1) dans Commander (commander.cc) + ame
+----------------------------
+revision 1.22
+date: 2006/05/31 12:30:13;  author: ansari;  state: Exp;  lines: +20 -11
+correction gestion & pour ThrExec ds Commander - Reza 31/05/2006
+----------------------------
+revision 1.21
+date: 2006/05/29 17:27:35;  author: ansari;  state: Exp;  lines: +37 -16
+Ajout gestionnaire signal ds ZThread et correction/adaptation gestion des thread
+s (killthr) dans Commander - Reza 29 mai 2006
+----------------------------
+revision 1.20
+date: 2006/04/26 15:22:08;  author: ansari;  state: Exp;  lines: +55 -15
+ajout methode ZThread::kill() pour envoi de signal a un thread + remplacement Ca
+ncelThread par StopThread (par kill/SIGUSR1) dans Commander (commander.cc) + ame
+lioration documentation , Reza 26/4/2006
+
+\end{verbatim}
 
 Mars-Avril 2004 : 
@@ -682,4 +731,7 @@
 
 \section{FitsIOServer}
+Juin 2006 : \\
+Ajout verification/correction noms de colonne lors de lecture FITS / DataTable, 
+et remplacement throw par un warning lors de lecture fits-healpix avec $nbcols > 1$ \\[1mm]
 Septembre-Novembre 2005 : Refondation totale du module 
 \begin{itemize}
@@ -750,4 +802,6 @@
 \item[\rond] Codage Options graphiques en text (string) pour PIGraphicAtt  (Nov-Dec 2005) 
 \item[\rond] Corrections diverses trace d'axes  etc ... (Dec 2005) 
+\item[\rond] PIext rendu indpendant de FITS (Avril 2006) - commandes spcifiques dans 
+ProgPI/fitsbtadapter.cc 
 
 \end{itemize}
@@ -895,9 +949,24 @@
 \subsection{piapp}
 \begin{itemize}
+\item[\rond] Avril 2006: Ajout possibilite de lecture des commandes sur le terminal (stdin) 
+et flag en argument de commande {\tt -small} \\
+Extrait de cvs log :
+\begin{verbatim}
+revision 1.16
+date: 2006/04/26 15:53:18;  author: ansari;  state: Exp;  lines: +20 -11
+1/ Ajout classe de lecture sur stdin (terminal) avec thread separe pour
+piapp - incluant la possibilite d'utilisation de la librairie GNU readline
+(fichiers piacmdrdr.cc piacmdrdr.h + fichier makfile specifique makefile_wgrdl
+ pour compil+link avec GNU readline)
+2/ MAJ Makefile et modif programme principal piapp.cc avec flag -small
+et activation thread de lecture sur terminal
+                           Reza , 26/04/2006
+
+----------------------------
+\end{verbatim}
+
 \item[\rond] Jan 2006 : commandes readfits writefits scanfits ont ete ajoutees 
 dans ProgPI/fitsbtadapter.cc en utilisant le nouveau FITS - 
 Le menu OpenFits de PIStdImgApp utilise desormais ces commandes
-\item[\rond] Jan 2006 - IMPORTANT - Tester et supprimer alors toute reference a FITS dans 
-PIext/  : nobjmgr.cc .h et les objadapter.
 \item[\rond] Possibilit d'execution de commandes en multithread (Avril 2005)
 \item[\rond] Le multithreading a t mis en oeuvre dans piapp (janvier 2004). 