Index: trunk/Eval/JET/results.txt
===================================================================
--- trunk/Eval/JET/results.txt	(revision 2939)
+++ trunk/Eval/JET/results.txt	(revision 2972)
@@ -2,4 +2,6 @@
 Performances classes tableaux en C++ et expression templates
 ------------------------------------------------------------
+<<<< Mise a jour mesures avec SOPHYA V=1.960 - 10 Juin 2006
+Compile sur asc> soit avec -O -g soit -fast (ascfast) 
 
 <<<< Comparaison/resultats du 23/04/2003  >>>>
@@ -61,7 +63,8 @@
 <ElAcc>: 
 ElAcc_1 : fortran, acces natif tableaux 2-D
-          C/C++, pointeur double * p = new double[size]; acces p[i]
-ElAcc_2 : Classe SimpleMatrix<T> / surcharge d'operateur
-ElAcc_3 : Classe SOPHYA::TMatrix<T> / surcharge d'operateur 
+          C/C++, pointeur double * p = new double[size]; acces p[i] 
+          tjet(31)
+ElAcc_2 : Classe SimpleMatrix<T> / surcharge d'operateur tjet(1)
+ElAcc_3 : Classe SOPHYA::TMatrix<T> / surcharge d'operateur tjet(21)
 
 ------------------------------------------------------------
@@ -83,14 +86,30 @@
 ascfast_tjet:     0.55       0.63       0.60
 ------------------------------------------------------------
-
+Juin 2006 - SOPHYA compile avec les options standard 
+-O -g1 asc_tjet et avec -fast ascfast_tjet
+asc_tjet:         0.98       1.2        1.28
+ascfast_tjet:     0.57       0.63       0.60
+............................................................
+Juin 2006 : pour le f77 et f90 (fmtx.f f90mtx.f90) - il n'y 
+pas de difference entre le temps avec -O et -fast
+asc_fmtx:         3.5
+asc_f90mtx:       0.7         
+............................................................
+Juin 2006 : sur ccali avec icc et ifort 
+Compile avec option par defaut -O 
+ali_tjet:         0.81       0.88       0.96
+ali_fmtx:         1.27 
+ali_f90mtx:       1.29
+------------------------------------------------------------
 
 <CMAdd> 
 CMAdd_1 : fortran, boucle + acces natif tableaux 2-D
           C/C++, pointeur double * p = new double[size]; boucle p[i] = q[i] ....
+	  tjet(32)
 CMAdd_2 : fortran / appel BLAS (copy/ CstMult/ VecAdd)
-CMAdd_3 : C++/SimpleMatrix<T>::MultCst() / AddElt()
-CMAdd_4 : C++/JET : SimpleMatrix<T>:: operator overload with Exp. Templates
-CMAdd_5 : SOPHYA::TMatrix<T>::MultCst() / AddElt()
-CMAdd_6 :  SOPHYA::TMatrix<T>::operator overlaod
+CMAdd_3 : C++/SimpleMatrix<T>::MultCst() / AddElt() tjet(2)
+CMAdd_4 : C++/JET : SimpleMatrix<T>:: operator overload with Exp. Templates tjet(3)
+CMAdd_5 : SOPHYA::TMatrix<T>::MultCst() / AddElt()   tjet(22)
+CMAdd_6 : SOPHYA::TMatrix<T>::operator overlaod  tjet(23)
            CMAdd_5, CMAdd_6 : mx = mx1*c1 + mx2*c2 + mx3*c3
 
@@ -116,4 +135,21 @@
 ascfast_tjet:    0.72                1.05      1.42       2.55      2.52
 --------------------------------------------------------------------------
+--------------------------------------------------------------------------
+Juin 2006 - SOPHYA compile avec les options standard 
+-O -g1 asc_tjet et avec -fast ascfast_tjet
+asc_tjet:         0.7                1.52      1.83       2.13      2.47
+ascfast_tjet:     0.75               1.04      1.4        1.31      1.51
+.........................................................................
+Juin 2006 : pour le f77 et f90 (fmtx.f f90mtx.f90) - il n'y 
+pas de difference entre le temps avec -O et -fast
+asc_fmtx:         4.4      0.68
+asc_f90mtx:       0.26   
+.........................................................................
+Juin 2006 : sur ccali avec icc et ifort 
+Compile avec option par defaut -O 
+ali_tjet:         0.66               2.8       0.65       1.91      2.9
+ali_fmtx:         1.37     0.79
+ali_f90mtx:       0.36
+--------------------------------------------------------------------------
 
 
@@ -124,4 +160,7 @@
 le fortran de DEC/Compaq (/HP) arrive a faire tendre le temps de calcul 
 vers zero dans certains cas, independant de la taille des tableaux !
+ Note de Juin 2006: f90 est effectivement tres efficace pour effectuer 
+ les operations sur tableaux natifs - verification sur OSF / f90
+ et Linux/ifort (compilo Intel)
 
 2/ l'optimisation -arch host -fast (code d'execution rapide adapte a 
@@ -129,5 +168,6 @@
 ameliorer les performances - Cela est peut-etre imputable a 
 la librairie SOPHYA, compile avec -g -O , pour proc alpha generique.
-
+  Note de Juin2006: En compilant SOPHYA aussi avec -fast, on gagne,
+  voir ci-dessus.
 
 3) Decembre 2003 - Resultats sur asc (OSF1-cxx , flag -fast) 
@@ -140,3 +180,5 @@
 TArray<T> (fichier tarray.cc) - 
 Hypothese a verifier 
+  Juin 2006 : les optimisations des operations sur tableaux (Juil04
+  et Avr06) ont apparemment remedie a ce probleme.
 