Index: trunk/SophyaLib/Manual/modifs.tex
===================================================================
--- trunk/SophyaLib/Manual/modifs.tex	(revision 2992)
+++ trunk/SophyaLib/Manual/modifs.tex	(revision 2993)
@@ -378,22 +378,35 @@
 
 
-\section{SkyMap , Samba }
-
-\subsection{Samba: SphericalTransformServer}
-{\bf Mai 2006:} Optimisation calcul transform en harmoniques sphriques - 
-Extrait de cvs log :
-\begin{verbatim}
-revision 1.8
-date: 2006/06/01 11:34:50;  author: ansari;  state: Exp;  lines: +147 -12
-1/ passage en sa_size_t (au lieu de int) dans Alm<T> et Bm<T>
-2/ Ajout des methodes optimisees (statiques) pour calcul transforme Ylm
-ds LambdaLMBuilder et utilisation ds SphericalTransformServer
-                             Reza , 1/06/2006
-\end{verbatim}
-
-\subsection{Tests et vrifications des polynomes de Legendre} 
-CMV ???
-
-\subsection{SphereECP} 
+\section{SkyMap} 
+
+\begin{itemize}
+\item[\rond] Juin 2006: Prise en charge du rangement mmoire {\bf NESTED} dans 
+les SphereHEALPix , + I/O PPF et FITS
+\item[\rond] Juin 2006:  Nettoyage et amliorations diverses dans les classes 
+Vector3d, UnitVector, LongLat \ldots et les cartes sphriques, en particulier : 
+\begin{enumerate}
+\item Nettoyage/uniformation mthodes  {\tt Print()}  des cartes, et 
+ ajout de la mthode {\tt Show()} dans PixelMap 
+ \item Ajout mthodes {\tt HasSymThetaSlice() , GetSymThetaSliceIndex() }
+ dans les cartes sphriques (SphericalMap) 
+ \item Ajout methode {\tt ResolToSizeIndex() SizeIndexToResol() } 
+ ds SphereThetaPhi , SphereHEALPix et SphereECP
+ \item Petites optimisations dans {\tt GetThetaSlice()} + methode {\tt GetThetaSliceDataPtr() }
+ \end{enumerate}
+
+\item[\rond] Juin 2006: Introduction de la classe {\bf Angle}  - pour conversion d'angle. 
+\begin{verbatim}
+   // Example to convert 0.035 radians to arcsec
+   double vr = 0.035;
+   cout << "Angle rad= " << vr << " ->arcsec= " << Angle(vr).ToArcSec() << endl;
+   // Example to convert 2.3 arcmin to radian - we use the conversion operator
+   double vam = 2.3;
+   cout << "Angle arcmin= " << vam << " ->rad= " 
+        << (double)Angle(vam, Angle::ArcMin) << endl;
+\end{verbatim} 
+%
+
+
+\item[\rond]  {\bf SphereECP} - Septembre 2004 \\
 Extrait du message du 7 Septembre 2004 
 \begin{verbatim}
@@ -417,5 +430,5 @@
 \end{verbatim} 
 
-\subsection{Bug non corrig ds classe Circle} 
+\item[\rond]  Bug non corrig ds classe Circle 
 \begin{verbatim}
 From: Laurence Perotto <perotto@cdf.in2p3.fr>
@@ -435,5 +448,48 @@
     Laurence.
 \end{verbatim} 
-
+\end{itemize}
+
+\section{Samba }
+
+\begin{itemize}
+\item[\rond] {\bf Juin 2006:} correction bug de calcul $a_{lm} \rightarrow$ SphereHEALPix 
+(zones polar cap): le problme venant du choix de taille lors du calcul de la transform
+de Fourier complex $\rightarrow$ rel (n/2 - 1 ou n/2 -2) .
+Correction dans {\tt RfourierSynthesisFromB } et utilisation de cette mthode
+pour tout type de carte.
+On gagne un peu encore en temps de calcul - sur asc (OSF1-cxx) , avec 
+SphereThetaPhi(m=400), $l_{max} = 511$ \\[2mm]
+\begin{tabular}{|l|c|c|}
+\hline
+Opration & TCPU Avant & TCPU Aprs OPT \\
+\hline
+map $\rightarrow a_{lm}$ & 10 s & 3.6 s. \\
+$a_{lm} \rightarrow$ map & 26 & 10.5 s. \\
+\hline
+\end{tabular}  \\[1mm]
+%
+\item[\rond] {\bf Mai 2006:}  Optimisation calcul transform en harmoniques sphriques 
+{\bf SphericalTransformServer}. \\
+Au lieu de calculer un tableau de $\lambda_{lm}$ dans LambdaLMBuilder 
+et utiliser ensuite ce tableau, on calcule les sommes ncessaires au vol,
+dans des mthodes spcifiques de la classe LambdaLMBuilder qui 
+sont utilises dans SphericalTransformServer (pour les transforms
+scalaire/temprature) - PAS fait pour la polarisation pour le moment.
+On peut encore gagner un facteur 2 en utilisant la symtrie 
+en $\theta <> \pi-\theta$. \\ 
+Extrait de cvs log :
+\begin{verbatim}
+revision 1.8
+date: 2006/06/01 11:34:50;  author: ansari;  state: Exp;  lines: +147 -12
+1/ passage en sa_size_t (au lieu de int) dans Alm<T> et Bm<T>
+2/ Ajout des methodes optimisees (statiques) pour calcul transforme Ylm
+ds LambdaLMBuilder et utilisation ds SphericalTransformServer
+                             Reza , 1/06/2006
+\end{verbatim}
+
+\item[\rond] Tests et vrifications des polynomes de Legendre CMV ???
+\end{itemize}
+
+%%%%%%%%%%%
 \section{SysTools} 
 {\bf Mai-Juin 2006 } classe ZThread - petites modifs/amliorations lies