Index: trunk/SophyaLib/Manual/sophya.tex
===================================================================
--- trunk/SophyaLib/Manual/sophya.tex	(revision 2919)
+++ trunk/SophyaLib/Manual/sophya.tex	(revision 2996)
@@ -170,4 +170,6 @@
 
 \section{Using Sophya}
+The organisation of SOPHYA directories and some of the associated 
+utility programs are described in this section.
 Basic usage of Sophya classes are described in in the following sections.
 Complete Sophya documentation can be found at our web site
@@ -186,9 +188,16 @@
 In order to use the shared libraries, the {\bf LD\_LIBRARY\_PATH} variable
 should contain the Sophya shared library path 
-({\tt \$SOPHYABASE/slb }). \\
-On Silocon Graphics machines (IRIX64) , the default SOPHYA configuration
-correspond to the 64 bit architecture. 
+({\tt \$SOPHYABASE/slb }). 
+On Silicon Graphics machines with IRIX64 operating system, 
+the default SOPHYA configuration correspond to the 64 bit architecture. 
 The environment variable { \bf LD\_LIBRARY64\_PATH } defines
 the shared library path in this case and should contain ({\tt \$SOPHYABASE/slb }.
+On IBM machines with AIX, the {\bf LIBPATH} environment variables 
+contains the shared libraries serach path.
+
+When using the dynamic load services in SOPHYA ({\tt PDynLinkMgr}
+class), in runcxx or (s)piapp applications for example, the shared 
+library search path must contain the current working directory (
+dot . in unix).
 
 The configure script creates links for external libraries include files in : 
@@ -267,4 +276,24 @@
 \end{verbatim}
 
+\subsection{the scanppf program}
+{\bf scanfits} is a SOPHYA program using the FitsIOServer 
+\footnote{FitsIOServer module uses the cfitsio library. scanfits has to be linked with
+with FitsIOServer module and cfitsio libraries, or libextsophya.so}
+module which can be used 
+to analyse the content of FITS files. It can list the FITS headers,  the appropriate 
+SOPHYA-FITS handler (implementing {\tt FitsHandlerInterface}) class, and the list of
+all registered  FITS handlers. 
+\begin{verbatim}
+csh> scanfits -h
+ SophyaInitiator::SophyaInitiator() BaseTools Init
+ PIOPersist::Initialize() Starting Sophya Persistence management service 
+SOPHYA Version  1.9 Revision 33 (V_Mar2006) -- Apr  3 2006 14:04:07 gcc 3.3 20030304 (Apple Computer, Inc. build 1495)
+ Usage: scanfits [flags] filename 
+ flags = -V1 -lh -rd -header 
+   -V1 : Scan using old (V1) code version 
+   -lh : Print the list of registered handlers (FitsHandlerInterface) 
+   -rd : try to read each HDU data using appropriate handler 
+   -header : List header information 
+\end{verbatim}
 
 \newpage
@@ -435,7 +464,8 @@
 \end{verbatim}
 
-\subsection{Using DVList}
-\index{DVList} \index{MuTyV}
+\subsection{DVList, MuTyV and TimeStamp classes}
+\index{DVList} \index{MuTyV} \index{TimeStamp}
 \begin{figure}[hbt]
+\dclsa{MuTyV}
 \dclsbb{AnyDataObj}{DVList}
 \dclsbb{PPersist}{\tclsc{ObjFileIO}{DVList}}
@@ -446,4 +476,5 @@
 capable of holding string, integer, float or complex values, 
 providing easy conversion methods between these objects.
+{\bf MuTyV} objects can also hold {\bf TimeStamp } objects.
 \begin{verbatim}
 // Using MuTyV objects
@@ -462,4 +493,29 @@
 \end{verbatim}
 
+\begin{figure}[hbt]
+\dclsbb{AnyDataObj}{TimeStamp}
+\end{figure}
+%
+The {\bf TimeStamp} class represent date and time and provides
+many standard operations, such as Initialisation from strings,
+conversion to strings and time interval computations. \\
+Usage example:
+\begin{verbatim}
+// Create a object with the current date and time and prints it to cout
+TimeStamp ts; 
+cout << ts << endl;
+// Create an object with a specified date and time 
+TimeStamp ts2("01/01/1905","00:00:00");
+// Get the number of days since 0 Jan 1901
+cout << ts2.ToDays() << endl;
+
+// Combined use of TimeStamp and MuTyV 
+string s;         
+TimeStamp ts;      // Current date/time
+MuTyV mvt = ts;
+s = mvt;           // s contains the current date in string format
+cout << s << endl;
+\end{verbatim}
+
 \subsection{\tcls{SegDataBlock} , \tcls{SwSegDataBlock}}
 \begin{figure}[hbt]
@@ -471,8 +527,10 @@
 type {\bf T} with reference sharing in memory. The array can be extended
 (increase in array size) with fixed segment size. It implements the interface
-defined by tcls{SegDBInterface}.
-\item[] \tcls{SwSegDataBlock} Implements the same tcls{SegDBInterface}
-using a data swapper (\tcls{DataSwapperInterface} . 
-Can thus be used for very large objects.
+defined by \tcls{SegDBInterface}.
+\item[] \tcls{SwSegDataBlock} Implements the same \tcls{SegDBInterface}
+using a data swapper object. Data swappers implement the interface defined in 
+(\tcls{DataSwapperInterface} class.  \tcls{SwSegDataBlock} can 
+thus be used to handle arrays with very large number of objects.
+These classes handles reference sharing.
 \end{itemize}
  
@@ -958,7 +1016,8 @@
 \section{Module HiStats}
 \begin{figure}[hbt]
-\dclsccc{AnyDataObj}{Histo}{HProf}
+\dclsbb{AnyDataObj}{Histo}
+\dclscc{Histo}{HProf}
+\dclscc{Histo}{HistoErr}
 \dclsbb{AnyDataObj}{Histo2D}
-\dclsbb{AnyDataObj}{Ntuple}
 \caption{partial class diagram for histograms and ntuples}
 \end{figure}